import sys
sys.dont_write_bytecode = True

import xmc

if __name__ == "__main__":

    # RandomGeneratorWrapper
    randomGeneratorInputDict = {'parameters': [2, 6],'generator': 'numpy.random.beta'}

    # SolverWrapper
    solverWrapperInputDict = {'index':[],'parameters':None}

    # SampleGenerator
    samplerInputDict = {'randomGenerator': 'xmc.randomGeneratorWrapper.RandomGeneratorWrapper',
                'randomGeneratorInputDict':randomGeneratorInputDict,
                'solverWrapper': 'xmc.classDefs_solverWrapper.KratosSolverWrapper.KratosSolverWrapper',
                'solverWrapperInputDict':solverWrapperInputDict,
                'solverWrapperIndices':None}

    # Moment Estimators
    qoiEstimatorInputDict = {'order':1,'indexSetDimension':0}
    costEstimatorInputDict = {'order':1,'indexSetDimension':0}

    # MonteCarloIndex Constructor
    mci_inputDict = {'indexValue': None,
                'sampler':'xmc.sampleGenerator.SampleGenerator',
                'samplerInputDict':samplerInputDict,
                'qoiEstimator':['xmc.momentEstimator.MomentEstimator'],
                'qoiEstimatorInputDict':[qoiEstimatorInputDict],
                'costEstimator':'xmc.momentEstimator.MomentEstimator',
                'costEstimatorInputDict':costEstimatorInputDict
    }

    ################################# RUN TIME GENERATED ENTITIES END HERE #######################

    # MonoCriterion
    statErrorCriterion = xmc.monoCriterion.MonoCriterion('xmc.methodDefs_monoCriterion.criterionFunctions.isLowerThanOrEqualTo',0.1)

    # MultiCriterion
    criteriaDict = [statErrorCriterion]
    criterionInputs = [['error0']]
    criterion = xmc.multiCriterion.MultiCriterion(criteria=criteriaDict,
                                                  inputsForCriterion=criterionInputs,
                                                  interpreter='xmc.methodDefs_multiCriterion.interpreter.interpretAsStoppingFlag',
                                                  flag='xmc.methodDefs_multiCriterion.flag.plainFlag')

    
    # ErrorEstimator
    statErrorEstimator = xmc.errorEstimator.ErrorEstimator(
        error='xmc.methodDefs_errorEstimator.errorEstimation.errorEstimationStatError_Task')

    # HierarchyOptimiser
    inputDict = {'indexSpace': [1,1],
                 'toleranceSplittingBounds': [.5]*2,
                 'optimalIndexSet': 'xmc.methodDefs_hierarchyOptimiser.optimalIndexSet.zeroDimensionSamplesOnly',
                 'optimalSampleNumbers': 'xmc.methodDefs_hierarchyOptimiser.optimalSampleNumbers.singleIndexAdaptive',
                 'defaultHierarchy': [[[],15]]
                }
    hierarchyCostOptimiser = xmc.hierarchyOptimiser.HierarchyOptimiser(**inputDict)
    
    # EstimationAssembler
    expectationAssembler = xmc.estimationAssembler.EstimationAssembler(
        assembleEstimation='xmc.methodDefs_estimationAssembler.assembleEstimation.assembleValue_Task')
    varianceAssembler = xmc.estimationAssembler.EstimationAssembler(
        assembleEstimation='xmc.methodDefs_estimationAssembler.assembleEstimation.assembleStatisticalError_Task')

    # MonteCarloSampler
    inputDict = {'indices': [],
                'indexConstructor':'xmc.monteCarloIndex.MonteCarloIndex',
                'indexConstructorDictionary':mci_inputDict,
                'assemblers': [expectationAssembler,varianceAssembler],
                'estimatorsForAssembler': [ [[0,[1, True, False]]],[[0,[1, True, True]]] ],
                'qoiPredictor': [],
                'estimatorsForPredictor': [[None]],
                'costPredictor': None,
                'errorEstimators': [statErrorEstimator],
                'assemblersForError': [[1]],
            }
    mcSampler = xmc.monteCarloSampler.MonteCarloSampler(**inputDict)

    # XMCAlgorithm
    inputDict = {'monteCarloSampler': mcSampler,
                'hierarchyOptimiser': hierarchyCostOptimiser,
                'stoppingCriterion': criterion,
                'errorsForStoppingCriterion': [0],
                'predictorsForHierarchy': [],
                'estimatorsForHierarchy': [[0,[1,True,True]]],
                'tolerancesForHierarchy': [0],
        }

    algo = xmc.XMCAlgorithm(**inputDict)

    algo.runXMC()
